#ifndef __autoptr_h_bisq
#define __autoptr_h_bisq

template <class t>
class autoptr
{
private:
	t *p;
	void Del()
	{
//		debugmsg << "***** Deleting " << (void*)p << "("<<(p?p->getname():"")<<")"<<" (self="<<(void*)this<<")"; if(p)debugmsg << ", ref " << p->refnum; debugmsg<<endl;
		if(p && !--p->refnum)delete p;
	}
	void Set(t *a)
	{
		if(a)++a->refnum;
//		debugmsg << "***** Re-assigning " << (void*)p << "("<<(p?p->getname():"")<<",ref="<<(p?p->refnum:0)<<")" << " (self="<<(void*)this<<")" << " <- " << (void*)a << "("<<a->getname()<<")"; if(a)debugmsg << ", ref " << a->refnum; debugmsg<<endl;
		if(p && !--p->refnum)delete p;
		p = a;
	}
public:
	autoptr() : p(NULL)
	{
//		debugmsg << "***** Created NULL " << " (self="<<(void*)this<<")"<<endl;
	}
	autoptr(t *a)
	{
		p=a; if(p)++p->refnum;
//		debugmsg << "***** Value-assigned " << (void*)p << "("<<(p?p->getname():"")<<")" << " (self="<<(void*)this<<")"; if(p)debugmsg << ", ref " << p->refnum; debugmsg<<endl;
	}
	autoptr &operator= (t *a) { Set(a); return *this; }
	autoptr &operator= (const autoptr<t> &a) { Set(&*a); return *this; }
	t &operator* () const { return *p; }
	t *operator-> () const { return p; }
	operator t *() { return p; }
	~autoptr() { Del(); }
	
	autoptr(const autoptr<t> &a)
	{
		p=(t *)&*a; if(p)++p->refnum;
//		debugmsg << "***** Class-assigned " << (void*)p << "("<<(p?p->getname():"")<<")" << " (self="<<(void*)this<<")"; if(p)debugmsg << ", ref " << p->refnum; debugmsg<<endl;
	}
};

#endif
