#ifndef MAKEDEPEND
#include <cmath>
#endif

#include "expr_minusplus.h"
#include "expr_2op.h"

static void hack(exprp s, autoptr<expr_minusplus> tmp, char op)
{
	if(s->ID != ext_pairfun)
	{
	giveup:
//		cout << "Adding " << s->getname() << ", '" << op << "'\n";
		tmp->insert(s, op);
		// Tmn jlkeen s:n muistinhallinta on tmp:n vastuulla,
		// joten sit ei deletoida tss eik kutsuneessa.
		return;
	}
	expr_2op *p = (expr_2op *)&*s;

	register char dop = (p->fun==expr_plus_fun) ? '+'
	                  : (p->fun==expr_minus_fun) ? '-' : 0;
	if(!dop)goto giveup;
	
	if(op=='-')dop = dop=='+' ? '-' : '+';
	
	hack(p->left, tmp, op);
	hack(p->right, tmp, dop);
}

static void hack2(exprp s, autoptr<expr_fractions> tmp, char op)
{
	if(s->ID != ext_pairfun)
	{
	giveup:
//		cout << "Adding " << s->getname() << ", '" << op << "'\n";
		tmp->insert(s, op);
		return;
	}
	expr_2op *p = (expr_2op *)&*s;

	register char dop = (p->fun==expr_times_fun) ? '*'
	                  : (p->fun==expr_divided_fun) ? '/' : 0;
	if(!dop)goto giveup;
	
	if(op=='/')dop = dop=='*' ? '/' : '*';
	
	hack2(p->left, tmp, op);
	hack2(p->right, tmp, dop);
}

exprp expr_2op::optimize()
{
	left = left->optimize();
	right = right->optimize();
	gettype();
	if(isconst)
	{
		if(left->type==str)
		{
			string a = left->getstr();
			string b =right->getstr();
			if(fun==expr_lt_fun)   return new expr_truth(a<b);
			if(fun==expr_gt_fun)   return new expr_truth(a>b);
			if(fun==expr_eq_fun)   return new expr_truth(a==b);
			if(fun==expr_lteq_fun) return new expr_truth(a<=b);
			if(fun==expr_gteq_fun) return new expr_truth(a>=b);
			if(fun==expr_neq_fun)  return new expr_truth(a!=b);
			#ifndef DUD2
			if(fun==expr_plus_fun) return new expr_string(a+b);
			#endif
		}
		expr_floattype a = left->getnum();
		expr_floattype b = right->getnum();
		if(fun==expr_lt_fun)   return new expr_truth(a<b);
		if(fun==expr_gt_fun)   return new expr_truth(a>b);
		if(fun==expr_eq_fun)   return new expr_truth(a==b);
		if(fun==expr_lteq_fun) return new expr_truth(a<=b);
		if(fun==expr_gteq_fun) return new expr_truth(a>=b);
		if(fun==expr_neq_fun)  return new expr_truth(a!=b);
		expr_floattype d = fun(a, b);
		if(d != d+d || d == a || d == b) /* infinity check */
			return new expr_number(d);
	}
	
	// At this point, the expression was not optimized.
	// Now we'll try to find why, and what _can_ we do.
	
	if(fun==expr_plus_fun || fun==expr_minus_fun)
	{
		autoptr<expr_minusplus> tmp = new expr_minusplus;
		
		hack(this, tmp, '+');
		// Siirt tmn objektin tmp:n sislle,
		// joten tt ei saa tuhota.
		
		return tmp->optimize();
	}
	
	if(fun==expr_times_fun || fun==expr_divided_fun)
	{
		autoptr<expr_fractions> tmp = new expr_fractions;
		
		hack2(this, tmp, '*');
		// Siirt tmn objektin tmp:n sislle,
		// joten tt ei saa tuhota.
		
		return tmp->optimize();
	}
	return this;	/* give up, can't optimize */
}
