#ifndef MAKEDEPEND
#include <ctime>
#endif

class expr_ftime : public expr
{
	exprp format;
public:
	expr_ftime(string &input)
	{
		format = expr::load(input, prio_high);
		if(!format)
			valid = false;
		else if(format->type == num)
		{
			format = NULL;
			valid = false;
		}
		else
			type = str;
	}
	virtual exprp calculate(calculate_args) const
	{
		char Buf[256];
		time_t t = time(NULL);
		struct tm *TM = localtime(&t);
		
		exprp result = format->calculate(calculate_call);
		
		strftime(Buf, (sizeof Buf)-1, result->getstr().c_str(), TM);

		return new expr_string(Buf);
	}
	virtual const string getname() const
	{
		return "ftime(\"" + format->getname() + "\")";
	}
};
