#include "expr_minusplus.h"

#ifndef MAKEDEPEND
#include <algorithm>
#include <cstdio>	// sprintf
#include <cmath>
#endif

exprp expr_minusplus::optimize()
{
	expr_floattype val=0;
redo:
	for(jonotype::iterator i = jono.begin(); i != jono.end(); ++i)
	{
	//	cout<<i->second.posi<<","<<i->second.nega<<" '" << i->first << "'\n";
		if(i->second.posi == i->second.nega)	/* value: 0 */
		{
			jono.erase(i);
			goto redo;
		}
		if(i->second.ex->ID == ext_number)
		{
			val += i->second.ex->getnum() * (i->second.posi-i->second.nega);
			jono.erase(i);
			goto redo;
		}
	}
	
	if(val!=0)
		if(val<0)
			jono.insert(new expr_number(-val), -1);
		else
			jono.insert(new expr_number(val), 1);
			
	if(jono.size()==1)
	{
		if(jono.begin()->second.posi-jono.begin()->second.nega==1)
		{
			exprp ret = jono.begin()->second.ex->optimize();
			return ret;
		}
	}
	if(jono.size()==0)
		return new expr_number(0);
	
	return this;
}

exprp expr_minusplus::calculate(calculate_args) const
{
	autoptr<expr_minusplus> tmp = new expr_minusplus;
	
	for(jonotype::const_iterator i = jono.begin(); i != jono.end(); ++i)
	{
		exprp t = i->second.ex->calculate(calculate_call);
		expr_floattype count = i->second.posi - i->second.nega;
		
		// t was result of calculate(), so it must be deleted.
		
		if(t->ID == ext_fractions)
		{
			expr_fractions *p = (expr_fractions *)&*t;
			exprp pr = p->jono.begin()->second.ex;
			if(pr->ID != ext_number)goto NextElse;
			expr_floattype val = pr->getnum();
			p->jono.erase(p->jono.begin());
			tmp->insert(t->calculate(calculate_call), val);
		}
 		else NextElse: if(t->ID == ext_number)
		{
			expr_floattype n = t->getnum();
			tmp->insert(new expr_number(n*count), 1.0L);
		}
		/*else if(count != 1)
		{
			autoptr <expr_fractions> p = new expr_fractions;
			p->insert(new expr_number(count), '*');
			p->insert(t->optimize(), '*');
			tmp->insert(p, 1.0);
		}*/
		else
		{
			/* move it to tmp, don't delete */
			tmp->insert(t, count);
		}
	}
	/* ok */
	return tmp->optimize();
}

const string expr_minusplus::getname() const
{
	string s;
	/* positiiviset ensin */
	for(jonotype::const_iterator i = jono.begin(); i != jono.end(); ++i)
	{
		expr_floattype count = i->second.posi - i->second.nega;
		if(count<0)continue;
		exprp ex = i->second.ex;
		
		if(s.size())s += '+';
		
		if(count!=1)
		{
			char Buf[64];
			sprintf(Buf, expr_format, count);
			s += Buf;
		}
		if(ex->ID != ext_number || count == 1)
		{
			if(count != 1)s += '*';
			s += i->first;
		}
	}
	/* negatiiviset sitten */
	for(jonotype::const_iterator i = jono.begin(); i != jono.end(); ++i)
	{
		expr_floattype count = i->second.posi - i->second.nega;
		if(count >= 0)continue;
		
		exprp ex = i->second.ex;
		
		count = -count;
		
		s += '-';
		
		if(count!=1)
		{
			char Buf[64];
			sprintf(Buf, expr_format, count);
			s += Buf;
		}
		if(ex->ID != ext_number || count == 1)
		{
			if(count != 1)s += '*';
			s += i->first;
		}
	}
	return '[' + s + ']';
}

exprp expr_fractions::optimize()
{
	expr_floattype mul=1, div=1;	
redo:
	for(jonotype::iterator i = jono.begin(); i != jono.end(); ++i)
	{
	//	cout<<i->second.posi<<","<<i->second.nega<<" '" << i->first << "'\n";
		if(i->second.posi == i->second.nega)
		{
			jono.erase(i);
			goto redo;
		}
		if(i->second.ex->ID == ext_number)
		{
			if(i->second.posi==0)
				div *= expr_pow_fun(i->second.ex->getnum(), i->second.nega);
			else
			{
				expr_floattype tmp = expr_pow_fun(i->second.ex->getnum(), i->second.posi-i->second.nega);
				tmp *= mul;
				if(tmp == tmp+tmp) /* infinity check */
				{
					continue;
				}
				mul = tmp;
			}
			jono.erase(i);
			goto redo;
		}
	}
	
	if(jono.size()==1)
	{
		jonotype::iterator i = jono.begin();
		if(i->second.ex->ID == ext_minusplus)
		{
			/* mul, div are now the numerical value of this fractions. */
			
			expr_minusplus *p = (expr_minusplus *) &*i->second.ex;
			for(jonotype::iterator i = p->jono.begin(); i != p->jono.end(); ++i)
			{
				/* 5 * (a+b+c) -> 5a + 5b + 5c */
				/* All the items will be multiplied by this. */
				expr_floattype count = (i->second.posi - i->second.nega) * mul/div;
				i->second.posi = count>0 ? count : 0;
				i->second.nega = count<0 ? -count : 0;
			}
			return p;
		}
	}
	
	/* Put the number back to the list */	
	if(div==1){if(mul!=1)jono.insert(new expr_number(mul), 1);}
	else if(mul==1)jono.insert(new expr_number(div), -1);
	else jono.insert(new expr_fraction(mul, div), 1);
	
	#if 0
	
	/* If there's only one thing left... */
	if(jono.size()==1)
	{
		if(jono.begin()->second.posi-
		   jono.begin()->second.nega == 1)
		{
			exprr ret = jono.begin()->second.ex->optimize();
			return ret;
		}
	}
	
	#endif
	
	// If the list is empty...
	if(jono.size()==0)return new expr_number(1);
	
	// No more optimizations.
	return this;
}

exprp expr_fractions::calculate(calculate_args) const
{
	autoptr <expr_fractions> tmp = new expr_fractions;
	
	for(jonotype::const_iterator i = jono.begin(); i != jono.end(); ++i)
	{
		exprp t = i->second.ex->calculate(calculate_call);
		
	/*	cout << "'" << i->first <<
		        "' ('" << i->second.ex->getname() << "')"
		        " became '" << t->getname() << "'\n";
	*/	
		// t, by calculate() has been new'ed.
		
		// t doesn't need to be deleted therefore, and this is correct.		
		tmp->insert(t, i->second.posi, i->second.nega);
	}
	
	// Optimization can be nice.	
	return tmp->optimize();
}

const string expr_fractions::getname() const
{
	bool eka=true;
	string s = "{";
	
#if 1
	/* ekaksi kertolaskut */
	for(jonotype::const_iterator i = jono.begin(); i != jono.end(); ++i)
	{
		expr_floattype pos = i->second.posi, neg = i->second.nega;
		if(pos==0 || neg!=0)continue;
		
		if(eka) eka = false; else s += '*';
		
		s += i->first;
		
		if(pos != 1)
		{
			char Buf[64];
			sprintf(Buf, "^" expr_format, pos);
			s += Buf;
		}
	}
	/* sitten jakolaskut */
	for(jonotype::const_iterator i = jono.begin(); i != jono.end(); ++i)
	{
		expr_floattype pos = i->second.posi, neg = i->second.nega;
		if(neg==0 || pos!=0)continue;
		
		if(eka) { s += '1'; eka = false; }
		s += '/';
		
		s += i->first;
		
		if(neg != 1)
		{
			char Buf[64];
			sprintf(Buf, "^" expr_format, neg);
			s += Buf;
		}
	}
#endif
	/* sitten murtoluvut */
	for(jonotype::const_iterator i = jono.begin(); i != jono.end(); ++i)
	{
		expr_floattype pos = i->second.posi, neg = i->second.nega;
		if(neg==0 || pos==0)continue;

		expr_floattype count = pos-neg;
		
		if(count >= 0)
			if(eka) eka=false; else	s += '*';
		else
		{
			count = -count;
			if(eka) { s += '1'; eka=false; }
			s += '/';
		}
			
		s += i->first;
		
		if(count != 1)
		{
			char Buf[64];
			sprintf(Buf, "^" expr_format, count);
			s += Buf;
		}
	}
//	cout << "diudau: " << s << ")\n";
	return s + '}';
}
